_asm_cpu_inst_adc_abs:
	get_absolute_byte .adcabs1

	mov	r0, r1	! r1 = src + A + carry
	mov	r0, r2
	add	r11, r1
	mov	r8,  r0
	and	#1, r0
	add	r0, r1  ! """"""""""""""""""""

	negative_zero_8bit r1	! set up N/Z flags for temp

	overflow_8bit	r11, r2, r1
	carry_8bit	r1, #255

	extu.b	r1, r1
	mov	r1, r11		! A += mem + carry .. seems like a lot, huh?

	! return from instruction
	mov.l	.adcabs0, r2
	jmp	@r2
	nop
.align 2
.adcabs0: .long _asm_cpu_execute_opcode_done
.adcabs1: .long _nes_read_byte


_asm_cpu_inst_and_abs:
	get_absolute_byte .andabs1
	and	r0, r11

	negative_zero_8bit r11	! setup N/Z flags

	mov.l	.andabs0, r2
	jmp	@r2
	nop
.align 2
.andabs0: .long _asm_cpu_execute_opcode_done
.andabs1: .long _nes_read_byte

_asm_cpu_inst_asl_abs:
	gw0_absolute_byte .aslabs1

	mov	#0xFE, r3
	and	r3, r8

	mov	#0x80, r3
	tst	r3, r0
	bt	0f

	mov	#1, r3
	or	r3, r8
0:
	shll	r0

	negative_zero_8bit r0
	gw1_absolute_byte .aslabs2
	mov.l	.aslabs0, r4
	jmp	@r4
	extu.b	r0, r0

.align 2
.aslabs0: .long _asm_cpu_execute_opcode_done
.aslabs1: .long _nes_read_byte
.aslabs2: .long _nes_write_byte

_asm_cpu_inst_bit_abs:
	get_absolute_byte .bitabs1

	mov	r0, r4
	instr_bit

	mov.l	.bitabs0, r2
	jmp	@r2
	nop
.align 2
.bitabs0: .long _asm_cpu_execute_opcode_done
.bitabs1: .long _nes_read_byte

_asm_cpu_inst_cmp_abs:
	get_absolute_byte .cmpabs1
        
	compare_8bit    r11, r0
                
	mov.l   .cmpabs0, r2
	jmp     @r2
	nop

.align 2
.cmpabs0: .long _asm_cpu_execute_opcode_done
.cmpabs1: .long _nes_read_byte

_asm_cpu_inst_cpx_abs:
	get_absolute_byte .cpxabs1
        
	compare_8bit    r10, r0
                
	mov.l   .cpxabs0, r2
	jmp     @r2
	nop

.align 2
.cpxabs0: .long _asm_cpu_execute_opcode_done
.cpxabs1: .long _nes_read_byte

_asm_cpu_inst_cpy_abs:
	get_absolute_byte .cpyabs1
        
	compare_8bit    r9, r0
                
	mov.l   .cpyabs0, r2
	jmp     @r2
	nop

.align 2
.cpyabs0: .long _asm_cpu_execute_opcode_done
.cpyabs1: .long _nes_read_byte

_asm_cpu_inst_dec_abs:
	gw0_absolute_byte .decabs1	! 1st part of ZP

	add	#-1, r0
	extu.b	r0, r0
	negative_zero_8bit r0

	gw1_absolute_byte .decabs2

	mov.l	.decabs0, r2
	jmp	@r2
	nop
.align 2
.decabs0: .long _asm_cpu_execute_opcode_done
.decabs1: .long _nes_read_byte
.decabs2: .long _nes_write_byte


_asm_cpu_inst_eor_abs:
	get_absolute_byte .eorabs1
	xor	r0, r11

	negative_zero_8bit r11	! setup N/Z flags

	mov.l	.eorabs0, r2
	jmp	@r2
	nop
.align 2
.eorabs0: .long _asm_cpu_execute_opcode_done
.eorabs1: .long _nes_read_byte


_asm_cpu_inst_inc_abs:
	gw0_absolute_byte .incabs1	! 1st part of ZP

	add	#1, r0
	extu.b	r0, r0
	negative_zero_8bit r0

	gw1_absolute_byte .incabs2

	mov.l	.incabs0, r2
	jmp	@r2
	nop
.align 2
.incabs0: .long _asm_cpu_execute_opcode_done
.incabs1: .long _nes_read_byte
.incabs2: .long _nes_write_byte

_asm_cpu_inst_jmp_abs:
	get_immediate_word .jmpabs1	
	mov.l	.jmpabs0, r2
	jmp	@r2
	mov	r0, r12
.align 2
.jmpabs0: .long _asm_cpu_execute_opcode_done
.jmpabs1: .long _nes_read_byte

_asm_cpu_inst_jmp_abi:
	get_immediate_word .jmpabi1	

	mov.l	.jmpabi2, r2
	jsr	@r2
	mov	r0, r4

	mov.l	.jmpabi0, r2
	jmp	@r2
	mov	r0, r12
.align 2
.jmpabi0: .long _asm_cpu_execute_opcode_done
.jmpabi1: .long _nes_read_byte
.jmpabi2: .long _nes_read_word

_asm_cpu_inst_jsr_abs:
	get_immediate_word .jsrabs1
	mov.l	r0, @-r15

	add	#-1, r12

	mov.l	.jsrabs2, r2
	mov	r12,r4
	jsr	@r2
	shlr8	r4

	mov	#255,r3
	extu.b	r3, r3
	mov.l	.jsrabs2, r2
	mov	r12,r4
	jsr	@r2
	and	r3,r4
	
	mov.l	.jsrabs0, r2
	jmp	@r2
	mov.l	@r15+, r12
.align 2
.jsrabs0: .long _asm_cpu_execute_opcode_done
.jsrabs1: .long _nes_read_byte
.jsrabs2: .long _asm_stack_push

_asm_cpu_inst_lda_abs:
	get_absolute_byte .ldaabs1
	mov	r0, r11

	negative_zero_8bit r11	! setup N/Z flags

	mov.l	.ldaabs0, r2
	jmp	@r2
	nop
.align 2
.ldaabs0: .long _asm_cpu_execute_opcode_done
.ldaabs1: .long _nes_read_byte

_asm_cpu_inst_ldx_abs:
	get_absolute_byte .ldxabs1
	mov	r0, r10

	negative_zero_8bit r10	! setup N/Z flags

	mov.l	.ldxabs0, r2
	jmp	@r2
	nop
.align 2
.ldxabs0: .long _asm_cpu_execute_opcode_done
.ldxabs1: .long _nes_read_byte

_asm_cpu_inst_ldy_abs:
	get_absolute_byte .ldyabs1
	mov	r0, r9

	negative_zero_8bit r9	! setup N/Z flags

	mov.l	.ldyabs0, r2
	jmp	@r2
	nop
.align 2
.ldyabs0: .long _asm_cpu_execute_opcode_done
.ldyabs1: .long _nes_read_byte


_asm_cpu_inst_ora_abs:
	get_absolute_byte .oraabs1
	or	r0, r11

	negative_zero_8bit r11	! setup N/Z flags

	mov.l	.oraabs0, r2
	jmp	@r2
	nop
.align 2
.oraabs0: .long _asm_cpu_execute_opcode_done
.oraabs1: .long _nes_read_byte

_asm_cpu_inst_rol_abs:
	gw0_absolute_byte .rolabs1
	
	mov	r8, r2

	mov	#0xFE, r3
	and	r3, r8

	mov	r0, r1
	tst	#0x80, r0
	bt	0f

	mov	#1, r4
	or	r4, r8	! set carry
0:
	shll	r0
	
	mov	#1, r4
	tst	r4, r2	! was carry previously set?
	bt	1f	! no?
	or	r4, r0  ! yes, set bit 0 to 1
1:
	gw1_absolute_byte .rolabs2
	mov.l	.rolabs0, r2
	jmp	@r2
	nop
.align 2
.rolabs0: .long _asm_cpu_execute_opcode_done
.rolabs1: .long _nes_read_byte
.rolabs2: .long _nes_write_byte

_asm_cpu_inst_sbc_abs:
	get_absolute_byte .sbcabs1

	mov	r0, r4
	instr_sbc

	mov.l	.sbcabs0, r2
	jmp	@r2
	nop
.align 2
.sbcabs0: .long _asm_cpu_execute_opcode_done
.sbcabs1: .long _nes_read_byte

_asm_cpu_inst_sta_abs:
	write_absolute_byte .staabs1, .staabs2, r11

	mov.l	.staabs0, r2
	jmp	@r2
	nop
.align 2
.staabs0: .long _asm_cpu_execute_opcode_done
.staabs1: .long _nes_read_byte
.staabs2: .long _nes_write_byte

_asm_cpu_inst_stx_abs:
	write_absolute_byte .stxabs1, .stxabs2, r10

	mov.l	.stxabs0, r2
	jmp	@r2
	nop
.align 2
.stxabs0: .long _asm_cpu_execute_opcode_done
.stxabs1: .long _nes_read_byte
.stxabs2: .long _nes_write_byte

_asm_cpu_inst_sty_abs:
	write_absolute_byte .styabs1, .styabs2, r9

	mov.l	.styabs0, r2
	jmp	@r2
	nop
.align 2
.styabs0: .long _asm_cpu_execute_opcode_done
.styabs1: .long _nes_read_byte
.styabs2: .long _nes_write_byte

