_asm_cpu_inst_adc_abx:
	get_absolutex_byte .adcabx1
	mov	r0, r1	! r1 = src + A + carry
	mov	r0, r2
	add	r11, r1
	mov	r8,  r0
	and	#1, r0
	add	r0, r1  ! """"""""""""""""""""

	negative_zero_8bit r1	! set up N/Z flags for temp

	overflow_8bit	r11, r2, r1
	carry_8bit	r1, #255

	extu.b	r1, r1
	mov	r1, r11		! A += mem + carry .. seems like a lot, huh?

	! return from instruction
	mov.l	.adcabx0, r2
	jmp	@r2
	nop
.align 2
.adcabx0: .long _asm_cpu_execute_opcode_done
.adcabx1: .long _nes_read_byte


_asm_cpu_inst_and_abx:
	get_absolutex_byte .andabx1
	and	r0, r11

	negative_zero_8bit r11	! setup N/Z flags

	mov.l	.andabx0, r2
	jmp	@r2
	nop
.align 2
.andabx0: .long _asm_cpu_execute_opcode_done
.andabx1: .long _nes_read_byte

_asm_cpu_inst_cmp_abx:
	get_absolutex_byte .cmpabx1
        
	compare_8bit    r11, r0
                
	mov.l   .cmpabx0, r2
	jmp     @r2
	nop

.align 2
.cmpabx0: .long _asm_cpu_execute_opcode_done
.cmpabx1: .long _nes_read_byte

_asm_cpu_inst_dec_abx:
	gw0_absolutex_byte .decabx1	! 1st part of ZP

	add	#-1, r0
	extu.b	r0, r0
	negative_zero_8bit r0

	gw1_absolutex_byte .decabx2

	mov.l	.decabx0, r2
	jmp	@r2
	nop
.align 2
.decabx0: .long _asm_cpu_execute_opcode_done
.decabx1: .long _nes_read_byte
.decabx2: .long _nes_write_byte


_asm_cpu_inst_eor_abx:
	get_absolutex_byte .eorabx1
	xor	r0, r11

	negative_zero_8bit r11	! setup N/Z flags

	mov.l	.eorabx0, r2
	jmp	@r2
	nop
.align 2
.eorabx0: .long _asm_cpu_execute_opcode_done
.eorabx1: .long _nes_read_byte


_asm_cpu_inst_inc_abx:
	gw0_absolutex_byte .incabx1	! 1st part of ZP

	add	#1, r0
	extu.b	r0, r0
	negative_zero_8bit r0

	gw1_absolutex_byte .incabx2

	mov.l	.incabx0, r2
	jmp	@r2
	nop
.align 2
.incabx0: .long _asm_cpu_execute_opcode_done
.incabx1: .long _nes_read_byte
.incabx2: .long _nes_write_byte

_asm_cpu_inst_lda_abx:
	get_absolutex_byte .ldaabx1
	mov	r0, r11

	negative_zero_8bit r11	! setup N/Z flags

	mov.l	.ldaabx0, r2
	jmp	@r2
	nop
.align 2
.ldaabx0: .long _asm_cpu_execute_opcode_done
.ldaabx1: .long _nes_read_byte

_asm_cpu_inst_ldy_abx:
	get_absolutex_byte .ldyabx1
	mov	r0, r9

	negative_zero_8bit r9	! setup N/Z flags

	mov.l	.ldyabx0, r2
	jmp	@r2
	nop
.align 2
.ldyabx0: .long _asm_cpu_execute_opcode_done
.ldyabx1: .long _nes_read_byte


_asm_cpu_inst_ora_abx:
	get_absolutex_byte .oraabx1
	or	r0, r11

	negative_zero_8bit r11	! setup N/Z flags

	mov.l	.oraabx0, r2
	jmp	@r2
	nop
.align 2
.oraabx0: .long _asm_cpu_execute_opcode_done
.oraabx1: .long _nes_read_byte

_asm_cpu_inst_rol_abx:
	gw0_absolutex_byte .rolabx1
	
	mov	r8, r2

	mov	#0xFE, r3
	and	r3, r8

	mov	r0, r1
	tst	#0x80, r0
	bt	0f

	mov	#1, r4
	or	r4, r8	! set carry
0:
	shll	r0
	
	mov	#1, r4
	tst	r4, r2	! was carry previously set?
	bt	1f	! no?
	or	r4, r0  ! yes, set bit 0 to 1
1:
	gw1_absolutex_byte .rolabx2
	mov.l	.rolabx0, r2
	jmp	@r2
	nop
.align 2
.rolabx0: .long _asm_cpu_execute_opcode_done
.rolabx1: .long _nes_read_byte
.rolabx2: .long _nes_write_byte

_asm_cpu_inst_sbc_abx:
	get_absolutex_byte .sbcabx1

	mov	r0, r4
	instr_sbc

	mov.l	.sbcabx0, r2
	jmp	@r2
	nop
.align 2
.sbcabx0: .long _asm_cpu_execute_opcode_done
.sbcabx1: .long _nes_read_byte


_asm_cpu_inst_sta_abx:
	write_absolutex_byte .staabx1, .staabx2, r11

	mov.l	.staabx0, r2
	jmp	@r2
	nop
.align 2
.staabx0: .long _asm_cpu_execute_opcode_done
.staabx1: .long _nes_read_byte
.staabx2: .long _nes_write_byte

