_asm_cpu_inst_adc_imm:
	get_immediate_byte .adcimm1
	mov	r0, r1	! r1 = src + A + carry
	mov	r0, r2
	add	r11, r1
	mov	r8,  r0
	and	#1, r0
	add	r0, r1  ! """"""""""""""""""""

	negative_zero_8bit r1	! set up N/Z flags for temp

	overflow_8bit	r11, r2, r1
	carry_8bit	r1, #255

	extu.b	r1, r1
	mov	r1, r11		! A += mem + carry .. seems like a lot, huh?

	! return from instruction
	mov.l	.adcimm0, r2
	jmp	@r2
	nop
.align 2
.adcimm0: .long _asm_cpu_execute_opcode_done
.adcimm1: .long _nes_read_byte

_asm_cpu_inst_and_imm:
	get_immediate_byte .andimm1
	and	r0, r11

	negative_zero_8bit r11	! set up N/Z flags for A

	mov.l	.andimm0, r2
	jmp	@r2
	nop
.align 2
.andimm0: .long _asm_cpu_execute_opcode_done
.andimm1: .long _nes_read_byte


_asm_cpu_inst_cmp_imm:
	get_immediate_byte .cmpimm1

	compare_8bit	r11, r0

	mov.l	.cmpimm0, r2
	jmp	@r2
	nop
.align 2
.cmpimm0: .long _asm_cpu_execute_opcode_done
.cmpimm1: .long _nes_read_byte

_asm_cpu_inst_cpx_imm:
	get_immediate_byte .cpximm1

	compare_8bit	r10, r0

	mov.l	.cpximm0, r2
	jmp	@r2
	nop
.align 2
.cpximm0: .long _asm_cpu_execute_opcode_done
.cpximm1: .long _nes_read_byte


_asm_cpu_inst_cpy_imm:
	get_immediate_byte .cpyimm1

	compare_8bit	r9, r0

	mov.l	.cpyimm0, r2
	jmp	@r2
	nop
.align 2
.cpyimm0: .long _asm_cpu_execute_opcode_done
.cpyimm1: .long _nes_read_byte


_asm_cpu_inst_eor_imm:
	get_immediate_byte .eorimm1
	xor	r0, r11

	negative_zero_8bit r11	! set up N/Z flags for A

	mov.l	.eorimm0, r2
	jmp	@r2
	nop
.align 2
.eorimm0: .long _asm_cpu_execute_opcode_done
.eorimm1: .long _nes_read_byte

_asm_cpu_inst_lda_imm:
	get_immediate_byte .ldaimm1
	mov	r0, r11

	negative_zero_8bit r11	! set up N/Z flags for A

	mov.l	.ldaimm0, r2
	jmp	@r2
	nop
.align 2
.ldaimm0: .long _asm_cpu_execute_opcode_done
.ldaimm1: .long _nes_read_byte

_asm_cpu_inst_ldx_imm:
	get_immediate_byte .ldximm1
	mov	r0, r10

	negative_zero_8bit r10

	mov.l	.ldximm0, r2
	jmp	@r2
	nop
.align 2
.ldximm0: .long _asm_cpu_execute_opcode_done
.ldximm1: .long _nes_read_byte

_asm_cpu_inst_ldy_imm:
	get_immediate_byte .ldyimm1
	mov	r0, r9

	negative_zero_8bit r9

	mov.l	.ldyimm0, r2
	jmp	@r2
	nop
.align 2
.ldyimm0: .long _asm_cpu_execute_opcode_done
.ldyimm1: .long _nes_read_byte

_asm_cpu_inst_ora_imm:
	get_immediate_byte .oraimm1
	or	r0, r11

	negative_zero_8bit r11	! set up N/Z flags for A

	mov.l	.oraimm0, r2
	jmp	@r2
	nop
.align 2
.oraimm0: .long _asm_cpu_execute_opcode_done
.oraimm1: .long _nes_read_byte

_asm_cpu_inst_sbc_imm:
	get_immediate_byte .sbcimm1

	mov	r0, r4
	instr_sbc

	mov.l	.sbcimm0, r2
	jmp	@r2
	nop
.align 2
.sbcimm0: .long _asm_cpu_execute_opcode_done
.sbcimm1: .long _nes_read_byte

