
! r4/r6 get killed
! R6 is Status Register
! val1 is a register
.macro	negative_zero_8bit 	val1
	mov.l	\val1,@-r15
	extu.b	\val1, \val1
	
	mov	#125, r4	! clear sign/zero
	and	r4, r8		! """""""""""""""
	
	mov	#0,r6
	cmp/eq	r6, \val1
	bf	1f
			
0:	! set_zero
	mov	#2, r4
	bra	2f
	or	r4, r8
1:	! check_sign
	mov	#0x80, r4
	extu.b	r4, r4
	tst	r4, \val1
	bt	2f
	or	r4, r8
2:	! done_nz8
	mov.l	@r15+, \val1
.endm

! r5/r4 get trashed
.macro  overflow_8bit 	accum, val1, val2
	mov	#191, r4	! clear overflow
	extu.b	r4, r4
	and	r4, r8
	
	mov	\accum, r4
	xor	\val1, r4
	mov	#0x80,r5
	extu.b	r5, r5
	and	r5, r4
	mov	#255, r5
	extu.b	r5, r5
	tst	r5, r4
	bf	9f
	
	mov	\accum, r4
	xor	\val2, r4
	mov	#0x80, r5
	extu.b	r5, r5
	and	r5, r4
	mov	#255, r5
	extu.b	r5, r5
	tst	r5, r4
	bt	9f
	
	mov	#64, r4
	or	r4, r8
9:
.endm

.macro  overflow_sbc_8bit 	accum, val1, val2
	mov	#191, r4	! clear overflow
	extu.b	r4, r4
	and	r4, r8
	
	mov	\accum, r4
	xor	\val1, r4
	mov	#0x80,r5
	extu.b	r5, r5
	and	r5, r4
	mov	#255, r5
	extu.b	r5, r5
	tst	r5, r4
	bt	9f
	
	mov	\accum, r4
	xor	\val2, r4
	mov	#0x80, r5
	extu.b	r5, r5
	and	r5, r4
	mov	#255, r5
	extu.b	r5, r5
	tst	r5, r4
	bt	9f
	
	mov	#64, r4
	or	r4, r8
9:
.endm

! r4/r6 are trashed
.macro carry_8bit	val, carryval=#255
	mov	#0xFE, r4
	extu.b	r4, r4
	and	r4, r8
	
	mov	\carryval, r6
	mov	\val, r4
	cmp/gt	r6, r4
	bf	8f
	
	mov	#1, r4
	or	r4, r8
8:
.endm


! r4/r5 get trashed
.macro compare_8bit	val1, val2
	mov	#124, r4
	and	r4, r8
	
	mov	\val1, r4
	mov	\val2, r5
	
	! if(val1 < val2) set_negative
	cmp/ge	r5, r4
	bt	0f
	
	bra	2f
	mov	#0x80, r4
0:
	! if(val == val2) set_zero (and carry? -- doc says to set carry)
	cmp/eq	r5, r4
	bf	1f
	
	bra	2f
	mov	#3, r4
1:
	! if(val1 > val2) set_carry
	cmp/gt	r5, r4
	bf	2f
	
	mov	#1, r4
2:
	extu.b	r4, r4
	or	r4, r8
.endm

.macro get_immediate_byte label
	mov.l	\label, r2	
	mov	r12, r4
	jsr	@r2
	add	#1, r12
	extu.b	r0, r0
.endm


!!!!!!! ZERO PAGE
.macro get_zeropage_byte label
	get_immediate_byte \label	! r0 = GET (PC), +1
	mov.l	\label, r2		! nes_read_byte(r0 & 0x00ff)
	jsr	@r2			! -------
	mov	r0, r4
.endm

.macro write_zeropage_byte label, label2, register
	get_immediate_byte \label	! r0 = GET (PC), +1
	mov	\register, r5
	mov.l	\label2, r2
	jsr	@r2			! nes_write_byte(r0 & 0x00FF, r5)
	mov	r0, r4
.endm


! NOTE: R4 will contain the resulting ZP address
! NOTE: R0 will contain @(R4)
.macro gw0_zeropage_byte label		! first half of a memory read/write addr mode
	get_immediate_byte \label
	mov.l	\label, r2
	mov	r0, r4
	jsr	@r2			! nes read_byte
	mov.l	r4, @-r15		! store the address for second half
	extu.b	r0, r0
.endm

! NOTE: R4 better NOT have been modified.
! NOTE: R0 is written to R4
.macro gw1_zeropage_byte label		! second half
	mov.l	@r15+, r4		! read address back
	mov.l	\label, r2
	jsr	@r2
	mov	r0, r5
.endm

!!!!!!! ZERO PAGE INDEXED X
.macro get_zeropagex_byte label
	get_immediate_byte \label	! r0 = GET (PC), +1
	mov.l	\label, r2		! nes_read_byte(r0 & 0x00ff)
	mov	r0, r4			!
	add	r10, r4			! indexed x 
	jsr	@r2			! -------
	extu.b	r4, r4			! --------------------------
.endm

.macro write_zeropagex_byte label, label2, register
	get_immediate_byte \label	! r0 = GET (PC), +1
	mov	\register, r5
	mov.l	\label2, r2
	mov	r0, r4
	add	r10, r4			! indexed x
	jsr	@r2			! nes_write_byte(r0 & 0x00FF, r5)
	extu.b	r4, r4
.endm


! NOTE: R4 will contain the resulting ZP address
! NOTE: R0 will contain @(R4)
.macro gw0_zeropagex_byte label		! first half of a memory read/write addr mode
	get_immediate_byte \label
	mov.l	\label, r2
	add	r10, r0
	extu.b	r0, r0
	mov	r0, r4
	jsr	@r2			! nes read_byte
	mov.l	r4, @-r15		! store the address for second half
	extu.b	r0, r0
.endm

! NOTE: R4 better NOT have been modified.
! NOTE: R0 is written to R4
.macro gw1_zeropagex_byte label		! second half
	mov.l	@r15+, r4		! read address back
	mov.l	\label, r2
	jsr	@r2
	mov	r0, r5
.endm

!!!!!!! ABSOLUTE
.macro get_immediate_word label
	get_immediate_byte \label
	mov.l	r0, @-r15
	get_immediate_byte \label
	shll8	r0
	mov.l	@r15+, r1
	or	r1, r0
	extu.w	r0, r0
.endm

.macro get_absolute_byte label
	get_immediate_word \label
		
	mov.l	\label, r2		! nes_read_byte(r0)
	jsr	@r2			! -------
	mov	r0, r4
.endm

.macro write_absolute_byte label, label2, register
	get_immediate_word \label
		
	mov	\register, r5
	mov.l	\label2, r2
	jsr	@r2			! nes_write_byte(r0 & 0x00FF, r5)
	mov	r0, r4
.endm


! NOTE: R4 will contain the resulting ZP address
! NOTE: R0 will contain @(R4)
.macro gw0_absolute_byte label		! first half of a memory read/write addr mode
	get_immediate_word \label
		
	mov.l	\label, r2
	mov	r0, r4
	jsr	@r2			! nes read_byte
	mov.l	r4, @-r15		! store the address for second half
	extu.b	r0, r0
.endm

! NOTE: R4 better NOT have been modified.
! NOTE: R0 is written to R4
.macro gw1_absolute_byte label		! second half
	mov.l	@r15+, r4		! read address back
	mov.l	\label, r2
	jsr	@r2
	mov	r0, r5
.endm

!!!!!!! ABSOLUTE INDEXED X
.macro get_absolutex_byte label
	get_immediate_word \label
	add	r10, r0
	extu.w	r0, r0
	
	mov.l	\label, r2		! nes_read_byte(r0)
	jsr	@r2			! -------
	mov	r0, r4
.endm

.macro write_absolutex_byte label, label2, register
	get_immediate_word \label
	add	r10, r0
	extu.w	r0, r0
		
	mov	\register, r5
	mov.l	\label2, r2
	jsr	@r2			! nes_write_byte(r0 & 0x00FF, r5)
	mov	r0, r4
.endm


! NOTE: R4 will contain the resulting ZP address
! NOTE: R0 will contain @(R4)
.macro gw0_absolutex_byte label		! first half of a memory read/write addr mode
	get_immediate_word \label
	add	r10, r0
	extu.w	r0, r0
		
	mov.l	\label, r2
	mov	r0, r4
	jsr	@r2			! nes read_byte
	mov.l	r4, @-r15		! store the address for second half
	extu.b	r0, r0
.endm

! NOTE: R4 better NOT have been modified.
! NOTE: R0 is written to R4
.macro gw1_absolutex_byte label		! second half
	mov.l	@r15+, r4		! read address back
	mov.l	\label, r2
	jsr	@r2
	mov	r0, r5
.endm

!!!!!!! ABSOLUTE INDEXED Y
.macro get_absolutey_byte label
	get_immediate_word \label
	add	r9, r0
	extu.w	r0, r0
	
	mov.l	\label, r2		! nes_read_byte(r0)
	jsr	@r2			! -------
	mov	r0, r4
.endm

.macro write_absolutey_byte label, label2, register
	get_immediate_word \label
	add	r9, r0
	extu.w	r0, r0
		
	mov	\register, r5
	mov.l	\label2, r2
	jsr	@r2			! nes_write_byte(r0 & 0x00FF, r5)
	mov	r0, r4
.endm


! NOTE: R4 will contain the resulting ZP address
! NOTE: R0 will contain @(R4)
.macro gw0_absolutey_byte label		! first half of a memory read/write addr mode
	get_immediate_word \label
	add	r9, r0
	extu.w	r0, r0
		
	mov.l	\label, r2
	mov	r0, r4
	jsr	@r2			! nes read_byte
	mov.l	r4, @-r15		! store the address for second half
	extu.b	r0, r0
.endm

! NOTE: R4 better NOT have been modified.
! NOTE: R0 is written to R4
.macro gw1_absolutey_byte label		! second half
	mov.l	@r15+, r4		! read address back
	mov.l	\label, r2
	jsr	@r2
	mov	r0, r5
.endm

!!!!!!! POSTINDEXED INDIRECT Y
! label = nes_read_byte, label2 = nes_read_word
.macro get_pi_indirecty_byte label, label2
	get_immediate_byte \label
	
	mov.l	\label2, r2		! offset = nes_read_word(src)
	jsr	@r2			! -------
	mov	r0, r4
	
	add	r9, r0			! offset = (offset + Y) & 0xFFFF;
	extu.w	r0, r0
	
	mov.l	\label, r2		! result = nes_read_byte(offset);
	jsr	@r2
	mov	r0, r4
.endm

! label = nes_read_byte ; label2 = nes_read_word, label3 = nes_write_byte
.macro write_pi_indirecty_byte label, label2, label3, register
	get_immediate_byte \label
	
	mov.l	\label2, r2		! offset = nes_read_word(src)
	jsr	@r2
	mov	r0, r4
	
	add	r9, r0			! offset = (offset + Y) & 0xFFFF;
	extu.w	r0, r0

	mov.l	\label3, r2
	mov	\register, r5
	jsr	@r2			! nes_write_byte(offset, value)
	mov	r0, r4
.endm


! NOTE: R4 will contain the resulting ZP address
! NOTE: R0 will contain @(R4)
! label = nes_read_byte | label2 = nes_read_word
.macro gw0_pi_indirecty_byte label, label2	! first half of a memory read/write addr mode
	get_immediate_byte \label
	
	mov.l	\label2, r2	! offset = nes_read_word(src);
	jsr	@r2
	mov	r0, r4
	
	add	r9, r0		! offset = (offset + Y) & 0xFFFF;
	extu.w	r0, r0
		
	mov.l	\label, r2	! value = nes_read_byte(offset);
	mov	r0, r4
	jsr	@r2	
	mov.l	r4, @-r15	! store the address for second half
	extu.b	r0, r0
.endm

! NOTE: R4 better NOT have been modified.
! NOTE: R0 is written to R4
! label = nes_write_byte
.macro gw1_absolutey_byte label		! second half
	mov.l	@r15+, r4		! read address back
	mov.l	\label, r2
	jsr	@r2			! nes_write_byte(offset, value);
	mov	r0, r5
.endm


!!!!!!!! PC REL
.macro pcrel_set_8bit bitflag, branch=r0
	mov	\bitflag, r4
	extu.b	r4, r4
	tst	r4, r8
	bt	1f
	
	exts.b	\branch,\branch
	add	\branch,r12
1:
.endm

.macro pcrel_clear_8bit bitflag, branch=r0
	mov	\bitflag, r4
	extu.b	r4, r4
	tst	r4, r8
	bf	1f
	
	exts.b	\branch,\branch
	add	\branch,r12
1:
.endm
