_asm_cpu_inst_adc_piy:
	get_pi_indirecty_byte .adcpiy1, .adcpiy2

	mov	r0, r1	! r1 = src + A + carry
	mov	r0, r2
	add	r11, r1
	mov	r8,  r0
	and	#1, r0
	add	r0, r1  ! """"""""""""""""""""

	negative_zero_8bit r1	! set up N/Z flags for temp

	overflow_8bit	r11, r2, r1
	carry_8bit	r1, #255

	extu.b	r1, r1
	mov	r1, r11		! A += mem + carry .. seems like a lot, huh?

	! return from instruction
	mov.l	.adcpiy0, r2
	jmp	@r2
	nop
.align 2
.adcpiy0: .long _asm_cpu_execute_opcode_done
.adcpiy1: .long _nes_read_byte
.adcpiy2: .long _nes_read_word

_asm_cpu_inst_and_piy:
	get_pi_indirecty_byte .andpiy1, .andpiy2
	and	r0, r11

	negative_zero_8bit r11	! setup N/Z flags

	mov.l	.andpiy0, r2
	jmp	@r2
	nop
.align 2
.andpiy0: .long _asm_cpu_execute_opcode_done
.andpiy1: .long _nes_read_byte
.andpiy2: .long _nes_read_word

_asm_cpu_inst_cmp_piy:
	get_pi_indirecty_byte .cmppiy1, .cmppiy2
        
	compare_8bit    r11, r0
                
	mov.l   .cmppiy0, r2
	jmp     @r2
	nop

.align 2
.cmppiy0: .long _asm_cpu_execute_opcode_done
.cmppiy1: .long _nes_read_byte
.cmppiy2: .long _nes_read_word

_asm_cpu_inst_eor_piy:
	get_pi_indirecty_byte .eorpiy1, .eorpiy2
	xor	r0, r11

	negative_zero_8bit r11	! setup N/Z flags

	mov.l	.eorpiy0, r2
	jmp	@r2
	nop
.align 2
.eorpiy0: .long _asm_cpu_execute_opcode_done
.eorpiy1: .long _nes_read_byte
.eorpiy2: .long _nes_read_word

_asm_cpu_inst_lda_piy:
	get_pi_indirecty_byte .ldapiy1, .ldapiy2
	mov	r0, r11

	negative_zero_8bit r11	! setup N/Z flags

	mov.l	.ldapiy0, r2
	jmp	@r2
	nop
.align 2
.ldapiy0: .long _asm_cpu_execute_opcode_done
.ldapiy1: .long _nes_read_byte
.ldapiy2: .long _nes_read_word

_asm_cpu_inst_ora_piy:
	get_pi_indirecty_byte .orapiy1, .orapiy2
	or	r0, r11

	negative_zero_8bit r11	! setup N/Z flags

	mov.l	.orapiy0, r2
	jmp	@r2
	nop
.align 2
.orapiy0: .long _asm_cpu_execute_opcode_done
.orapiy1: .long _nes_read_byte
.orapiy2: .long _nes_read_word

_asm_cpu_inst_sbc_piy:
	get_pi_indirecty_byte .sbcpiy1, .sbcpiy2

	mov	r0, r4
	instr_sbc

	mov.l	.sbcpiy0, r2
	jmp	@r2
	nop
.align 2
.sbcpiy0: .long _asm_cpu_execute_opcode_done
.sbcpiy1: .long _nes_read_byte
.sbcpiy2: .long _nes_read_word

_asm_cpu_inst_sta_piy:
	write_pi_indirecty_byte .stapiy1, .stapiy2, .stapiy3, r11

	mov.l	.stapiy0, r2
	jmp	@r2
	nop
.align 2
.stapiy0: .long _asm_cpu_execute_opcode_done
.stapiy1: .long _nes_read_byte
.stapiy2: .long _nes_read_word
.stapiy3: .long _nes_write_byte

