_asm_cpu_inst_adc_zp:
	get_zeropage_byte .adczp1
	mov	r0, r1	! r1 = src + A + carry
	mov	r0, r2
	add	r11, r1
	mov	r8,  r0
	and	#1, r0
	add	r0, r1  ! """"""""""""""""""""

	negative_zero_8bit r1	! set up N/Z flags for temp

	overflow_8bit	r11, r2, r1
	carry_8bit	r1, #255

	extu.b	r1, r1
	mov	r1, r11		! A += mem + carry .. seems like a lot, huh?

	! return from instruction
	mov.l	.adczp0, r2
	jmp	@r2
	nop
.align 2
.adczp0: .long _asm_cpu_execute_opcode_done
.adczp1: .long _nes_read_byte

_asm_cpu_inst_and_zp:
	get_zeropage_byte .andzp1
	and	r0, r11

	negative_zero_8bit r11	! setup N/Z flags

	mov.l	.andzp0, r2
	jmp	@r2
	nop
.align 2
.andzp0: .long _asm_cpu_execute_opcode_done
.andzp1: .long _nes_read_byte

_asm_cpu_inst_asl_zp:
	gw0_zeropage_byte .aslzp1

	mov	#0xFE, r3
	and	r3, r8

	mov	#0x80, r3
	tst	r3, r0
	bt	0f

	mov	#1, r3
	or	r3, r8
0:
	shll	r0

	negative_zero_8bit r0
	gw1_zeropage_byte .aslzp2
	mov.l	.aslzp0, r4
	jmp	@r4
	extu.b	r0, r0

.align 2
.aslzp0: .long _asm_cpu_execute_opcode_done
.aslzp1: .long _nes_read_byte
.aslzp2: .long _nes_write_byte

_asm_cpu_inst_bit_zp:
	get_zeropage_byte .bitzp1

	mov	r0, r4
	instr_bit

	mov.l	.bitzp0, r2
	jmp	@r2
	nop
.align 2
.bitzp0: .long _asm_cpu_execute_opcode_done
.bitzp1: .long _nes_read_byte

_asm_cpu_inst_cmp_zp:
        get_zeropage_byte .cmpzp1
        
        compare_8bit    r11, r0
                
        mov.l   .cmpzp0, r2
        jmp     @r2
        nop

.align 2
.cmpzp0: .long _asm_cpu_execute_opcode_done
.cmpzp1: .long _nes_read_byte

_asm_cpu_inst_cpx_zp:
        get_zeropage_byte .cpxzp1
        
        compare_8bit    r10, r0
                
        mov.l   .cpxzp0, r2
        jmp     @r2
        nop

.align 2
.cpxzp0: .long _asm_cpu_execute_opcode_done
.cpxzp1: .long _nes_read_byte

_asm_cpu_inst_cpy_zp:
        get_zeropage_byte .cpyzp1
        
        compare_8bit    r9, r0
                
        mov.l   .cpyzp0, r2
        jmp     @r2
        nop

.align 2
.cpyzp0: .long _asm_cpu_execute_opcode_done
.cpyzp1: .long _nes_read_byte

_asm_cpu_inst_dec_zp:
	gw0_zeropage_byte .deczp1	! 1st part of ZP

	add	#-1, r0
	extu.b	r0, r0
	negative_zero_8bit r0

	gw1_zeropage_byte .deczp2

	mov.l	.deczp0, r2
	jmp	@r2
	nop
.align 2
.deczp0: .long _asm_cpu_execute_opcode_done
.deczp1: .long _nes_read_byte
.deczp2: .long _nes_write_byte


_asm_cpu_inst_eor_zp:
	get_zeropage_byte .eorzp1
	xor	r0, r11

	negative_zero_8bit r11	! setup N/Z flags

	mov.l	.eorzp0, r2
	jmp	@r2
	nop
.align 2
.eorzp0: .long _asm_cpu_execute_opcode_done
.eorzp1: .long _nes_read_byte


_asm_cpu_inst_inc_zp:
	gw0_zeropage_byte .inczp1	! 1st part of ZP

	add	#1, r0
	extu.b	r0, r0
	negative_zero_8bit r0

	gw1_zeropage_byte .inczp2

	mov.l	.inczp0, r2
	jmp	@r2
	nop
.align 2
.inczp0: .long _asm_cpu_execute_opcode_done
.inczp1: .long _nes_read_byte
.inczp2: .long _nes_write_byte

_asm_cpu_inst_lda_zp:
	get_zeropage_byte .ldazp1
	mov	r0, r11

	negative_zero_8bit r11	! setup N/Z flags

	mov.l	.ldazp0, r2
	jmp	@r2
	nop
.align 2
.ldazp0: .long _asm_cpu_execute_opcode_done
.ldazp1: .long _nes_read_byte

_asm_cpu_inst_ldx_zp:
	get_zeropage_byte .ldxzp1
	mov	r0, r10

	negative_zero_8bit r10	! setup N/Z flags

	mov.l	.ldxzp0, r2
	jmp	@r2
	nop
.align 2
.ldxzp0: .long _asm_cpu_execute_opcode_done
.ldxzp1: .long _nes_read_byte

_asm_cpu_inst_ldy_zp:
	get_zeropage_byte .ldyzp1
	mov	r0, r9

	negative_zero_8bit r9	! setup N/Z flags

	mov.l	.ldyzp0, r2
	jmp	@r2
	nop
.align 2
.ldyzp0: .long _asm_cpu_execute_opcode_done
.ldyzp1: .long _nes_read_byte

_asm_cpu_inst_lsr_zp:
	gw0_zeropage_byte .lsrzp1

	mov	#0xfe, r3
	and	r3, r8

	mov	#1, r4
	tst	r4, r0
	bt	0f
	
	or	r4, r8	! set carry
	
0:
	shlr	r0

	negative_zero_8bit r0

	gw1_zeropage_byte .lsrzp2

	mov.l	.lsrzp0, r2
	jmp	@r2
	nop
.align 2
.lsrzp0: .long _asm_cpu_execute_opcode_done
.lsrzp1: .long _nes_read_byte
.lsrzp2: .long _nes_write_byte

_asm_cpu_inst_ora_zp:
	get_zeropage_byte .orazp1
	or	r0, r11

	negative_zero_8bit r11	! setup N/Z flags

	mov.l	.orazp0, r2
	jmp	@r2
	nop
.align 2
.orazp0: .long _asm_cpu_execute_opcode_done
.orazp1: .long _nes_read_byte

_asm_cpu_inst_rol_zp:
	gw0_zeropage_byte .rolzp1
	
	mov	r8, r2

	mov	#0xFE, r3
	and	r3, r8

	mov	r0, r1
	tst	#0x80, r0
	bt	0f

	mov	#1, r4
	or	r4, r8	! set carry
0:
	shll	r0
	
	mov	#1, r4
	tst	r4, r2	! was carry previously set?
	bt	1f	! no?
	or	r4, r0  ! yes, set bit 0 to 1
1:
	gw1_zeropage_byte .rolzp2
	mov.l	.rolzp0, r2
	jmp	@r2
	nop
.align 2
.rolzp0: .long _asm_cpu_execute_opcode_done
.rolzp1: .long _nes_read_byte
.rolzp2: .long _nes_write_byte

_asm_cpu_inst_ror_zp:
	gw0_zeropage_byte .rorzp1
	
	mov	r8, r2

	mov	#0xFE, r3
	and	r3, r8

	mov	r0, r1
	tst	#0x01, r0
	bt	0f

	mov	#1, r4
	or	r4, r8	! set carry
0:
	shlr	r0
	
	mov	#1, r4
	tst	r4, r2	! was carry previously set?
	bt	1f	! no?
	mov	#0x80, r4
	or	r4, r0  ! yes, set bit 7 to 1
1:
	gw1_zeropage_byte .rorzp2
	mov.l	.rorzp0, r2
	jmp	@r2
	nop
.align 2
.rorzp0: .long _asm_cpu_execute_opcode_done
.rorzp1: .long _nes_read_byte
.rorzp2: .long _nes_write_byte

_asm_cpu_inst_sbc_zp:
	get_zeropage_byte .stazp1

	mov	r0, r4
	instr_sbc

	mov.l	.sbczp0, r2
	jmp	@r2
	nop
.align 2
.sbczp0: .long _asm_cpu_execute_opcode_done
.sbczp1: .long _nes_read_byte

_asm_cpu_inst_sta_zp:
	write_zeropage_byte .stazp1, .stazp2, r11

	mov.l	.stazp0, r2
	jmp	@r2
	nop
.align 2
.stazp0: .long _asm_cpu_execute_opcode_done
.stazp1: .long _nes_read_byte
.stazp2: .long _nes_write_byte

_asm_cpu_inst_stx_zp:
	write_zeropage_byte .stxzp1, .stxzp2, r10

	mov.l	.stxzp0, r2
	jmp	@r2
	nop
.align 2
.stxzp0: .long _asm_cpu_execute_opcode_done
.stxzp1: .long _nes_read_byte
.stxzp2: .long _nes_write_byte

_asm_cpu_inst_sty_zp:
	write_zeropage_byte .styzp1, .styzp2, r9

	mov.l	.styzp0, r2
	jmp	@r2
	nop
.align 2
.styzp0: .long _asm_cpu_execute_opcode_done
.styzp1: .long _nes_read_byte
.styzp2: .long _nes_write_byte
