_asm_cpu_inst_adc_zpx:
	get_zeropagex_byte .adczpx1
	mov	r0, r1	! r1 = src + A + carry
	mov	r0, r2
	add	r11, r1
	mov	r8,  r0
	and	#1, r0
	add	r0, r1  ! """"""""""""""""""""

	negative_zero_8bit r1	! set up N/Z flags for temp

	overflow_8bit	r11, r2, r1
	carry_8bit	r1, #255

	extu.b	r1, r1
	mov	r1, r11		! A += mem + carry .. seems like a lot, huh?

	! return from instruction
	mov.l	.adczpx0, r2
	jmp	@r2
	nop
.align 2
.adczpx0: .long _asm_cpu_execute_opcode_done
.adczpx1: .long _nes_read_byte

_asm_cpu_inst_and_zpx:
	get_zeropagex_byte .andzpx1
	and	r0, r11

	negative_zero_8bit r11	! setup N/Z flags

	mov.l	.andzpx0, r2
	jmp	@r2
	nop
.align 2
.andzpx0: .long _asm_cpu_execute_opcode_done
.andzpx1: .long _nes_read_byte

_asm_cpu_inst_cmp_zpx:
	get_zeropagex_byte .cmpzpx1
        
	compare_8bit    r11, r0
                
	mov.l   .cmpzpx0, r2
	jmp     @r2
	nop

.align 2
.cmpzpx0: .long _asm_cpu_execute_opcode_done
.cmpzpx1: .long _nes_read_byte


_asm_cpu_inst_dec_zpx:
	gw0_zeropagex_byte .deczpx1	! 1st part of ZP

	add	#-1, r0
	extu.b	r0, r0
	negative_zero_8bit r0

	gw1_zeropagex_byte .deczpx2

	mov.l	.deczpx0, r2
	jmp	@r2
	nop
.align 2
.deczpx0: .long _asm_cpu_execute_opcode_done
.deczpx1: .long _nes_read_byte
.deczpx2: .long _nes_write_byte


_asm_cpu_inst_eor_zpx:
	get_zeropagex_byte .eorzpx1
	xor	r0, r11

	negative_zero_8bit r11	! setup N/Z flags

	mov.l	.eorzpx0, r2
	jmp	@r2
	nop
.align 2
.eorzpx0: .long _asm_cpu_execute_opcode_done
.eorzpx1: .long _nes_read_byte


_asm_cpu_inst_inc_zpx:
	gw0_zeropagex_byte .inczpx1	! 1st part of ZP

	add	#1, r0
	extu.b	r0, r0
	negative_zero_8bit r0

	gw1_zeropagex_byte .inczpx2

	mov.l	.inczpx0, r2
	jmp	@r2
	nop
.align 2
.inczpx0: .long _asm_cpu_execute_opcode_done
.inczpx1: .long _nes_read_byte
.inczpx2: .long _nes_write_byte

_asm_cpu_inst_lda_zpx:
	get_zeropagex_byte .ldazpx1
	mov	r0, r11

	negative_zero_8bit r11	! setup N/Z flags

	mov.l	.ldazpx0, r2
	jmp	@r2
	nop
.align 2
.ldazpx0: .long _asm_cpu_execute_opcode_done
.ldazpx1: .long _nes_read_byte

_asm_cpu_inst_ldy_zpx:
	get_zeropagex_byte .ldyzpx1
	mov	r0, r9

	negative_zero_8bit r9	! setup N/Z flags

	mov.l	.ldyzpx0, r2
	jmp	@r2
	nop
.align 2
.ldyzpx0: .long _asm_cpu_execute_opcode_done
.ldyzpx1: .long _nes_read_byte


_asm_cpu_inst_ora_zpx:
	get_zeropagex_byte .orazpx1
	or	r0, r11

	negative_zero_8bit r11	! setup N/Z flags

	mov.l	.orazpx0, r2
	jmp	@r2
	nop
.align 2
.orazpx0: .long _asm_cpu_execute_opcode_done
.orazpx1: .long _nes_read_byte

_asm_cpu_inst_rol_zpx:
	gw0_zeropagex_byte .rolzpx1
	
	mov	r8, r2

	mov	#0xFE, r3
	and	r3, r8

	mov	r0, r1
	tst	#0x80, r0
	bt	0f

	mov	#1, r4
	or	r4, r8	! set carry
0:
	shll	r0
	
	mov	#1, r4
	tst	r4, r2	! was carry previously set?
	bt	1f	! no?
	or	r4, r0  ! yes, set bit 0 to 1
1:
	gw1_zeropagex_byte .rolzpx2
	mov.l	.rolzpx0, r2
	jmp	@r2
	nop
.align 2
.rolzpx0: .long _asm_cpu_execute_opcode_done
.rolzpx1: .long _nes_read_byte
.rolzpx2: .long _nes_write_byte

_asm_cpu_inst_sbc_zpx:
	get_zeropagex_byte .sbczpx1

	mov	r0, r4
	instr_sbc

	mov.l	.sbczpx0, r2
	jmp	@r2
	nop
.align 2
.sbczpx0: .long _asm_cpu_execute_opcode_done
.sbczpx1: .long _nes_read_byte

_asm_cpu_inst_sta_zpx:
	write_zeropagex_byte .stazpx1, .stazpx2, r11

	mov.l	.stazpx0, r2
	jmp	@r2
	nop
.align 2
.stazpx0: .long _asm_cpu_execute_opcode_done
.stazpx1: .long _nes_read_byte
.stazpx2: .long _nes_write_byte

_asm_cpu_inst_sty_zpx:
	write_zeropagex_byte .styzpx1, .styzpx2, r9

	mov.l	.styzpx0, r2
	jmp	@r2
	nop
.align 2
.styzpx0: .long _asm_cpu_execute_opcode_done
.styzpx1: .long _nes_read_byte
.styzpx2: .long _nes_write_byte
