#ifdef TARGET_DC
# ifndef __DC_H
# define __DC_H

#include "types.h"
#include "gleam!.h"

#define SIGINT 0
#define RGBS(r,g,b) (((r >> 3) << 10) | ((g >> 3) << 5) | ((b >> 3)))

#define vram_plot(__x,__y,__c) vram_l[32 + (__y * 640) + __x] = dc_colors[__c]

typedef int FILE;

FILE *stdout;

FILE *fopen(char *, char *);
int fprintf(FILE *, char *, ...);
int printf(char *, ...);
void signal(int, void (*)());
int fwrite(char *, int, int, FILE *);
int fread(char *, int, int, FILE *);
int fclose(FILE *);
void exit(int);
int fseek(FILE *, int, int);
int ftell(FILE *);
void *malloc(int);
void rewind(FILE *);
void puts(char *);
int time(int);

inline void video_memcpy64(void *, void *, int);
void vram_blit();
#ifndef vram_plot
void vram_plot(int, int, int);
#endif

void dc_init();
int gleam_poll_events();

extern u16 dc_colors[];

int dc_gleam_full_screen_option();
int dc_gleam_loadram_option();

# endif
#endif
