#ifndef __DCS_REGS_H
#define __DCS_REGS_H

#include "types.h"

#ifdef SOUNDCODE
# define DCS_SOUNDBASE 0
#else
# define DCS_SOUNDBASE 0xA0800000
#endif

typedef struct _command {
	u8 command;
	union {
		struct {
			u8 reg;
			u8 data;
		} read, write;
	} params;
} dcs_command;

#define DCS_SOUNDSIZE (2 * 1024 * 1024)
#define DCS_STATUS *((volatile u32 *)(DCS_SOUNDBASE | 0x1FFFC))
#define DCS_NES_REGS *((volatile u8 *)(DCS_SOUNDBASE | 0x1FFD0))
#define DCS_COMMAND ((volatile dcs_command *)(DCS_SOUNDBASE | 0x1FF00))

#define DCS_CMD_NONE 0x00
#define DCS_CMD_STOP 0x01
#define DCS_CMD_RESTART 0x02
#define DCS_CMD_WRITE 0x03
#define DCS_CMD_READ 0x04
#define DCS_CMD_PROCESS 0x05
#define DCS_CMD_OK 0xFF

#endif
