#define SOUNDCODE

#include "dcs_regs.h"

static void __gccmain() { }

void dcs_write()
{
	gleam_sound_write(DCS_COMMAND->params.write.reg, DCS_COMMAND->params.write.data);
	DCS_COMMAND->command = DCS_CMD_OK;
}

void dcs_read()
{
	DCS_COMMAND->params.read.data = gleam_sound_read(DCS_COMMAND->params.read.reg);
	DCS_COMMAND->command = DCS_CMD_OK;
}

int main()
{
	extern volatile unsigned int timer; /* TIMER is incremented every 1ms */
	
	DCS_STATUS = 0;	/* not ready */
	aica_reset();	
	
	/* code ... */
	DCS_STATUS = 1;
	while(1) {
		switch(DCS_COMMAND->command) {
			case DCS_CMD_WRITE:
				dcs_write();
				break;
			case DCS_CMD_READ:
				dcs_read();
				break;
			case DCS_CMD_NONE:
				if(timer > 1) {
					gleam_process_sound();
					timer = 0;
				}
				break;
			default:
				break;
		}
	}
	
	return 0;
}


