#ifndef __EMULATE_H
#define __EMULATE_H

#include "fileio.h"

#define PPUCNT1 nes_regs[0]
#	define PPUINC 0x04

#define PPUCNT2 nes_regs[1]
#define PPUSTAT nes_regs[2]
#define SPRRAMA nes_regs[3]
#define SPRRAMIO nes_regs[4]
#define BGSCROLL nes_regs[5]
# define BGSCROLLY (nes_regs[5] & 0x00FF)
# define BGSCROLLX ((nes_regs[5] & 0xFF00) >> 8)

#define VRAMADR nes_regs[6]
#define VRAMIO nes_regs[7]
#define JOYPAD1 nes_joy[0]
#define JOYPAD2 nes_joy[1]

extern u8 nes_ram[];
extern u16 nes_regs[];
extern u8 nes_soundregs[];
extern u8 nes_sram[];
extern u8 nes_vram[];
extern u8 nes_trainer[];
extern u8 nes_joy[];
extern u8 nes_sprram[];

extern u8 *prg_rom_8;
extern u8 *prg_rom_a;
extern u8 *prg_rom_c;
extern u8 *prg_rom_e;
extern u8 *prg_banks[];

extern u8 emulation_running;
extern u8 nes_single_screen_mirroring;

void nes_emulate(nes_file *);
void nes_set_rom_page(u8, u8);
void nes_set_chr_page(u8, u8);
void nes_set_rom_page32k(u8);
void nes_set_rom_page8k(u8, u8);
void nes_set_chr_page8k(u8);	/* 8k */
void nes_set_chr_page1k_by_addr(u16, u8);


typedef enum _cpu_type {
	CPU_M6502 = 0,
	CPU_ASM,
	CPU_G6502,
} cpu_type;

extern cpu_type current_cpu_type;

#endif
