#ifndef __G6502_H
#define __G6502_H


#include "types.h"

#define NMI_VECTOR   0xFFFA
#define RESET_VECTOR 0xFFFC
#define BREAK_VECTOR 0xFFFE

#define FL_CARRY 0x01
#define FL_CARRY_i 0
#define FL_ZERO  0x02
#define FL_ZERO_i 1
#define FL_INT   0x04
#define FL_INT_i 2
#define FL_DEC   0x08
#define FL_DEC_i 3
#define FL_SINT  0x10
#define FL_SINT_i 4
#define FL_OVERFLOW   0x40
#define FL_OVERFLOW_i 6
#define FL_NEGATIVE 0x80
#define FL_NEGATIVE_i 7

#define SET_FLAG(x,y,z) x.p = (x.p & ~y) | ((z) << (y##_i))
#define CYCLES(x,y) x.cycle_count += y

typedef struct _g6502_cpu {
	u16 pc, sp, p;
	u8 x, y, a;
	u16 cycle_count;
} g6502_cpu;

extern g6502_cpu gleam_cpu;

void g_unknown();
void g_brk_00();
void g_ora_05();
void g_asl_06();
void g_php_08();
void g_ora_09();
void g_asl_0a();
void g_bpl_10();
void g_asl_16();
void g_clc_18();
void g_jsr_20();
void g_and_25();
void g_plp_28();
void g_and_29();
void g_rol_2a();
void g_bit_2c();
void g_bmi_30();
void g_and_35();
void g_rol_36();
void g_sec_38();
void g_rti_40();
void g_eor_45();
void g_lsr_46();
void g_pha_48();
void g_eor_49();
void g_lsr_4a();
void g_jmp_4c();
void g_eor_4d();
void g_rts_60();
void g_pla_68();
void g_adc_65();
void g_ror_66();
void g_adc_69();
void g_ror_6a();
void g_adc_6d();
void g_sei_78();
void g_sty_84();
void g_sta_85();
void g_stx_86();
void g_dey_88();
void g_txa_8a();
void g_sty_8c();
void g_sta_8d();
void g_stx_8e();
void g_bcc_90();
void g_sta_91();
void g_sty_94();
void g_sta_95();
void g_tya_98();
void g_sta_99();
void g_txs_9a();
void g_sta_9d();
void g_ldy_a0();
void g_ldx_a2();
void g_ldy_a4();
void g_lda_a5();
void g_ldx_a6();
void g_tay_a8();
void g_lda_a9();
void g_tax_aa();
void g_ldy_ac();
void g_lda_ad();
void g_ldx_ae();
void g_bcs_b0();
void g_lda_b1();
void g_ldy_b4();
void g_lda_b5();
void g_lda_b9();
void g_ldy_bc();
void g_ldx_be();
void g_lda_bd();
void g_cpy_c0();
void g_cpy_c4();
void g_cmp_c5();
void g_dec_c6();
void g_iny_c8();
void g_cmp_c9();
void g_dex_ca();
void g_dec_ce();
void g_bne_d0();
void g_dec_d6();
void g_cld_d8();
void g_cmp_dd();
void g_cpx_e0();
void g_cpx_e4();
void g_sbc_e5();
void g_inc_e6();
void g_inx_e8();
void g_sbc_e9();
void g_nop_ea();
void g_inc_ee();
void g_beq_f0();
void g_inc_fe();

void g_do_nmi();
#endif
