#ifndef TARGET_DC
#include <stdio.h>
#include <stdlib.h>
#else
#include "dream.h"
#include "libc.h"
#include "dc.h"
#endif

#include "gleam!.h"
#include "emulate.h"
#include "m2.h"

u8 m3_read(u16 address)
{
        switch(address & 0xF000) {
                case 0x8000:
                case 0x9000:
                        return prg_banks[0][address & 0x1FFF];
                case 0xA000:
                case 0xB000:
                        return prg_banks[1][address & 0x1FFF];
                case 0xC000:
                case 0xD000:
                        return prg_banks[2][address & 0x1FFF];
                default:
                        return prg_banks[3][address & 0x1fff];
        }

}
void m3_write(u16 address, u8 value)
{
	if(value >= current_nes_file->chr_count) {
		gleamerror("CHR bank %d requested: doesn't exist\n", value);
	} else	{
		nes_set_chr_page(0, value<<1);
		nes_set_chr_page(1, (value<<1) + 1);
	}
}

void m3_init(nes_file *nf)
{
        if(nf->prg_count == 1) {
        	nes_set_rom_page(0, 0);
        	nes_set_rom_page(1, 0);
        } else if(nf->prg_count == 2) {
        	nes_set_rom_page(0, 0);
        	nes_set_rom_page(1, 1);
        } else {
        	gleamerror("mapper 3 requires only 1 or 2 pages of rom\n");
        	exit(1);
        }

	if(nf->chr_count >= 1) {
	       	nes_set_chr_page(0, 0);
       		nes_set_chr_page(1, 1);
       	} else {
       		gleamerror("mapper 3 requires at least 1 8k of chr ram\n");
       		exit(1);
       	}
}
