#ifndef TARGET_DC
#include <stdio.h>
#include <stdlib.h>
#else
#include "dream.h"
#include "libc.h"
#include "dc.h"
#endif

#include "gleam!.h"
#include "emulate.h"
#include "m7.h"

u8 m7_read(u16 address)
{
        switch(address & 0xF000) {
                case 0x8000:
                case 0x9000:
                        return prg_banks[0][address & 0x1FFF];
                case 0xA000:
                case 0xB000:
                        return prg_banks[1][address & 0x1FFF];
                case 0xC000:
                case 0xD000:
                        return prg_banks[2][address & 0x1FFF];
                default:
                        return prg_banks[3][address & 0x1fff];
        }
}

void m7_write(u16 address, u8 value)
{
	nes_set_rom_page32k(value & 0x0F);
	if(value & 0x10) 
		nes_single_screen_mirroring = 2;
	else
		nes_single_screen_mirroring = 1;
}

void m7_init(nes_file *nf)
{
       	nes_set_rom_page32k(0);

        if(nf->chr_count >= 1) {
        	nes_set_chr_page8k(0);
	}

	nes_single_screen_mirroring = 1;
}
