#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/soundcard.h>

void WriteSample(short int l, short int r);

#define BUFSIZE	11
short int buf[2 << (BUFSIZE - 1)];
int pos;
int audio_fd = -1;

void WriteSample(short int l, short int r)
{

	if (audio_fd == -1) {
		audio_buf_info info;
		int want, set;

		audio_fd = open("/dev/dsp", O_WRONLY);
		if (audio_fd == -1) {
			perror("open");
			exit(EXIT_FAILURE);
		}

		set = (9 << 16) | BUFSIZE;
		if (ioctl(audio_fd, SNDCTL_DSP_SETFRAGMENT, &set) == -1) {
			perror("ioctl SNDCTL_DSP_SETFRAGMENT");
			exit(EXIT_FAILURE);
		}

		want = set = AFMT_S16_LE;
		if (ioctl(audio_fd, SNDCTL_DSP_SETFMT, &set) == -1) {
			perror("ioctl SNDCTL_DSP_SETFMT");
			exit(EXIT_FAILURE);
		}
		if (want != set) {
			fprintf(stderr, "Format: Wanted %d, Got %d\n",
				want, set);
			exit(EXIT_FAILURE);
		}

		want = set = 1;
		if (ioctl(audio_fd, SNDCTL_DSP_STEREO, &set) == -1) {
			perror("ioctl SNDCTL_DSP_STEREO");
			exit(EXIT_FAILURE);
		}
		if (want != set) {
			fprintf(stderr, "Stereo: Wanted %d, Got %d\n",
				want, set);
			exit(EXIT_FAILURE);
		}

		want = set = 44100;
		if (ioctl(audio_fd, SNDCTL_DSP_SPEED, &set) == -1) {
			perror("ioctl SNDCTL_DSP_SPEED");
			exit(EXIT_FAILURE);
		}
		if (want != set) {
			fprintf(stderr, "Speed: Wanted %d, Got %d\n", want,
				set);
			exit(EXIT_FAILURE);
		}

		if (ioctl(audio_fd, SNDCTL_DSP_GETOSPACE, &info) == -1) {
			perror("ioctl SNDCTL_DSP_GETOSPACE");
			exit(EXIT_FAILURE);
		}
		printf("Fragments: %d\n", info.fragments);
		printf("FragTotal: %d\n", info.fragstotal);
		printf("Frag Size: %d\n", info.fragsize);
		printf("Bytes    : %d\n", info.bytes);
	}

	buf[pos + 0] = l;
	buf[pos + 1] = r;
	pos += 2;
	if (pos >= (sizeof(buf) / sizeof(buf[0]))) {
		//FILE *fp = fopen("sound.log", "ab");
		//fwrite(buf, 1, sizeof(buf), fp);
		//fclose(fp);
		write(audio_fd, buf, sizeof(buf));
		pos = 0;
	}
}
