# Adapted from Marcus' AICA example among a few other sources =)

.globl	arm_main
.text

# Reset vectors

# Reset
reset:
	b	start
# Undefined instruction
	b	undef
# Software interrupt
	b	undef
# Abort prefetch
	b	undef
# Abort data
	b	undef
# Reserved
	nop
# IRQ
	b	undef
# Fast IRQ
#	b	fiq
	b	undef


start:
	# Setup a basic stack, disable interupts
	mov	sp,#0xb000
	mrs	r10,CPSR
	orr	r10,r10,#0x40
	msr	CPSR_all,r10

	# Call the main for the SPU
	bl	arm_main

	# Loop infinitely if we get here
here:	b	here


# FIQ code adapted from the Marcus AICA example
fiq:
	# Save regs
	stmdb	sp!, {r8, r9, r14}

	# Call handler
#	bl	arm_fiq_handler

	# Clear interrupt
	ldr	r8,intclr
	mov	r9,#1
	str	r9,[r8]
	str	r9,[r8]
	str	r9,[r8]
	str	r9,[r8]

	# Restore regs and return
	ldmdb	sp!, {r8, r9, r14}
	sub	pc,r14,#4
	
intclr:
	.long	0x802d04


undef:
	b	undef






