/* This file is part of the Dreamcast function library.
 * Please see libdream.c for further details.
 *
 * (c)2000 Dan Potter
 */

#include "spu_control.h"

void cmd_play() {
	aica_play(CMD->ch, CMD->base, CMD->mode, CMD->len, CMD->freq,
		CMD->vol, CMD->pan);
	CMD->cmd = CMD_NONE;
}

void cmd_stop() {
	aica_stop(CMD->ch);
	CMD->cmd = CMD_NONE;
}

void cmd_stopall() {
	int i;
	for (i=0; i<64; i++)
		aica_stop(i);
	CMD->cmd = CMD_NONE;
}

void cmd_set_pan() {
	aica_pan(CMD->ch, CMD->pan);
	CMD->cmd = CMD_NONE;
}

void cmd_set_vol() {
	aica_vol(CMD->ch, CMD->vol);
	CMD->cmd = CMD_NONE;
}

void cmd_set_freq() {
	aica_freq(CMD->ch, CMD->vol);
	CMD->cmd = CMD_NONE;
}

int arm_main() {
	/* Start off by clearing out our command structures */
	HEARTBEAT = 0;		/* Zero heartbeat */
	CMD->cmd = CMD_NONE;	/* No command to process */
	
	/* Initialize the AICA part of the SPU */
	aica_init();
	
	/* Now loop, waiting for commands from the SH4. */
	while (1) {
		/* Wait for a command */
		do {
			HEARTBEAT++;
		} while (CMD->cmd == CMD_NONE);
		
		/* Figure out what it is */
		switch(CMD->cmd) {
			case CMD_PLAY:
				cmd_play(); break;
			case CMD_STOP:
				cmd_stop(); break;
			case CMD_STOPALL:
				cmd_stopall(); break;
		}
	}
}






