/*
 * This file is part of the Dreamcast function library.
 * Please see libdream.c for further details.
 *
 * (C)2000 Jordan DeLong
 */

#include "maple.h"

/* Endianness conversion */
unsigned int read_belong(unsigned int *l) {
  unsigned char *b = (unsigned char *)l;
  
  return (b[0] << 24) | (b[1] << 16) | (b[2] << 8) | b[3];
}

void write_belong(unsigned int *l, unsigned int v) {
  unsigned char *b = (unsigned char *)l;
  
  b[0] = v >> 24;
  b[1] = v >> 16;
  b[2] = v >> 8;
  b[3] = v;
}

/********************************************
 * dc_cont_get_buttons()
 *	simple function:  does same thing as done
 * in marcus's maple bus demo.  Returns -1
 * on error...
 ********************************************/
short dc_cont_get_buttons(int port) {
	char *res;
	unsigned int func;
	unsigned int params[1];
	
	write_belong(&params[0], MAPLE_FUNC_CONTROLLER);
	do {
		res = dc_maple_docmd(port, 0, MAPLE_COMMAND_GETCOND, 1, params);
	} while (*res == MAPLE_RESPONSE_AGAIN);
	
	if (*res == MAPLE_RESPONSE_DATATRF && res[3] >= 2
		&& read_belong((unsigned int *)(res + 4)) == MAPLE_FUNC_CONTROLLER) {
		return *((unsigned short *)(res + 8));
	}
	
	return -1;
}
