/* This file is part of the Dreamcast function library.
 * Please see libdream.c for further details.
 *
 * (c)2000 Dan Potter, Mike Brent
 */

#include <stdarg.h>
#include "dream.h"

// External assembler functions (going to get rid of these eventually)
int  InitSerial(int);
void WriteSerial(char*);
int  ReadSerial();

/* Call to initialize the serial driver. You must call this before
   using WriteSerial() or dc_serial_printf(). */
void dc_serial_init() {
	InitSerial(57600);
}

/* This is a wrapper function for WriteSerial, and was written
   by Mike Brent. */
void dc_serial_printf(char *fmt, ...) {
	va_list		args;
	char		pbuf[2048];

	va_start(args, fmt);
	vsprintf(pbuf, fmt, args);
	va_end(args);

	WriteSerial(pbuf);
}

/* This is a wrapper function for ReadSerial */
int dc_serial_getchar() {
	int c;
	while ((c = ReadSerial()) == -1)
		;
	return c;
}





